--[[
structure i is the characters name
	List [i]	.Note
				.Alt [i] (list)
				.Main (flag)]]--
				
--Future improvement; Fix left:right pane width as 1/3:2/3

import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"

highlight=Turbine.UI.Color( 0.4,0.4,0.4 ) --Colour used to highlight mains

if type(class)~="function" then Turbine.Shell.WriteLine("Are base Turbine Plugins installed? Please check their installation before using AltTracker. If this error persists please contact MrJackdaw.") return end

import "JackdawPlugins.AltTracker.function"

function ShowWindow()

	Display=Turbine.UI.Lotro.Window()

	Display:SetPosition(x,y)
	Display:SetVisible(true)
	Display:SetText("Alt Tracker")
	
	Display.Closed=function()
		--At least clear out some of the data!
		Display=nil	node=nil	subNodes=nil altNode=nil
	end
		
	Display.PositionChanged=function()
		x,y=Display:GetPosition()
	end
	
	Display.Resize=Turbine.UI.Control()
		Display.Resize:SetParent(Display)
		Display.Resize:SetZOrder(99)
		Display.Resize:SetSize(10,10)
		Display.Resize:SetPosition(width-10,height-10)
		
		Display.ResizeBack=Turbine.UI.Control()
		Display.ResizeBack:SetParent(Display.Resize)
		Display.ResizeBack:SetSize(10,10)
		Display.ResizeBack:SetBackColor(Turbine.UI.Color(1,1,1,1))
		Display.ResizeBack:SetVisible(false)
		Display.ResizeBack:SetMouseVisible(false)
	
	Display.Fold=Turbine.UI.Control()
		Display.Fold:SetParent(Display)
		Display.Fold:SetZOrder(99)
		Display.Fold:SetVisible(true)
		Display.Fold:SetSize(8,30)
	Display.FoldGraphic=Turbine.UI.Control()
		Display.FoldGraphic:SetParent(Display.Fold)
		Display.FoldGraphic:SetSize(78,78)
		Display.FoldGraphic:SetMouseVisible(false)
		Display.FoldGraphic:SetBackground(0x41007e08)
		Display.FoldGraphic:SetStretchMode(1)
		Display.FoldGraphic:SetSize(8,30)

	Display.Fold.MouseClick=function()
		fold=not(fold)
		if fold then Display:SetWidth(width*2) else Display:SetWidth(width/2) end
	end
	
	Display.Resize.MouseEnter=function() Display.ResizeBack:SetVisible(true) end
	Display.Resize.MouseLeave=function() Display.ResizeBack:SetVisible(false)  end
	
	Display.Resize.MouseDown=function ()
		dragging=true
	end
	Display.Resize.MouseUp=function ()
		dragging=false
	end
	Display.Resize.MouseMove=function()
		if dragging then
			width,height=Display:GetMousePosition()
			if not fold then if width<150 then width=150 end else	if width<300 then width=300 end end
			if height<300 then height=300 end
			Display:SetSize(width,height)
		end
	end

	Display.SizeChanged=function()
		width,height=Display:GetSize()
		if fold then
			size.w=(width-30)/2
		else
			size.w=width-20
		end
		size.h=height-50
		Display.LeftFrame:SetSize(size.w,size.h)
		Display.RightFrame:SetSize(size.w,size.h)
		Display.Resize:SetPosition(width-10,height-10)
		Display.Fold:SetPosition(width-10,height/2)
	end
	
	LeftFrame()
	RightFrame()
	
	Display:SetSize(width,height)
	
	if Char~=nil then 
		SetCharacter(Char)
		node[Char]:SetExpanded(true)
	end
	
end
	
function LeftFrame()

Display.LeftFrame=Frame()

	Display.LeftFrame:SetParent(Display)
	
	Display.LeftFrame:SetPosition(10,40)
	
	table.insert(Display.LeftFrame.SizeChange,function()
		Display.treeView:SetSize(size.w-25,height-100)
		Display.scriptTextScrollBar:SetSize( 10, height-100 )
		Display.Search:SetSize(size.w-25,20)
		Display.SearchField:SetSize(size.w-25-30,15)
		Display.Clear:SetPosition(size.w-25-16,0)
		Display.Mains:SetSize(size.w-25,20)
		Display.Mains:SetPosition(10,size.h-25+2)
	end)

	 -- Create the tree view control.
	Display. treeView = Turbine.UI.TreeView()
		Display.treeView:SetParent( Display.LeftFrame )
		Display.treeView:SetPosition( 20, 30 )
		Display.treeView:SetIndentationWidth( 15 )
		
	-- Give the tree view a scroll bar.
	Display.scriptTextScrollBar = Turbine.UI.Lotro.ScrollBar()
		Display.scriptTextScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
		Display.scriptTextScrollBar:SetParent( Display.LeftFrame )
		Display.scriptTextScrollBar:SetPosition( 5, 30 )

		Display.treeView:SetVerticalScrollBar( Display.scriptTextScrollBar )
	--Add the tree
	Tree(SearchString)
	
	Display.Mains=Turbine.UI.Lotro.CheckBox()
		Display.Mains:SetParent( Display.LeftFrame )
		Display.Mains:SetText("Show only Main Characters as root")
		Display.Mains:SetChecked(ShowOnlyMains)
		Display.Mains.CheckedChanged=function() 
			ShowOnlyMains=not ShowOnlyMains 
			ShowWindow() 
		end
		
	Display.Search = Turbine.UI.Control()
		Display.Search:SetParent( Display.LeftFrame )
		Display.Search:SetPosition( 5, 10 )
		
		Display.SearchLabel=Turbine.UI.Label()
			Display.SearchLabel:SetParent( Display.Search )
			Display.SearchLabel:SetPosition( 0,0 )
			Display.SearchLabel:SetSize(50,20)
			Display.SearchLabel:SetText("Search:")
		Display.SearchField=Turbine.UI.TextBox()
			Display.SearchField:SetParent( Display.Search )
			Display.SearchField:SetPosition( 50,0 )
			Display.SearchField:SetText("Search for")
			Display.SearchField:SetBackColor(Turbine.UI.Color(1,0.2,0.2,0.2))
		Display.Clear=Turbine.UI.Control()
			Display.Clear:SetVisible(true)
			Display.Clear:SetParent(Display.Search)
			Display.Clear:SetBackground(0x41007e26)
			Display.Clear:SetSize(16,16)
			Display.Clear.MouseClick=function() Display.SearchField:SetWantsUpdates( false ) SearchString=nil ShowWindow() end		
			
			Display.SearchField:SetWantsKeyEvents( true );
			Display.SearchField:SetWantsUpdates( false );

	Display.SearchField.KeyDown = function( sender, args )
		Search(SearchString)
	end

	Display.SearchField.FocusGained = function()
		if Display.SearchField:GetText()=="Search for" then Display.SearchField:SetText("") end
		Display.SearchField:SetWantsUpdates( true );
	end
	
	Display.SearchField.FocusLost = function()
		Display.SearchField:SetWantsUpdates( false );
	end
	
	Display.SearchField.Update = function()
		if SearchString ~= Display.SearchField:GetText() then
			SearchString = Display.SearchField:GetText()
			Search(SearchString)
		end
	end
			
	Display.LeftFrame:SetSize(size.w,size.h)
end

function Tree()
-- Populate the Tree nodes.
		rootNodes = Display.treeView:GetNodes()
		node=nil	node={}	subNodes=nil subNodes={}	altNode=nil altNode={}
		if Len(List)>0 then
			for i in orderedPairs(List) do
					node[i] = MyTreeNode()
					if ShowOnlyMains then
						if List[i].Main then rootNodes:Add( node[i] ) end
					else
						rootNodes:Add( node[i] )
					end
					
					if List[i].Main then
						node[i].text:SetOutlineColor( highlight );
						node[i].text:SetFontStyle( Turbine.UI.FontStyle.Outline );
					else
						node[i].text:SetFontStyle( Turbine.UI.FontStyle.None );
					end
					
					node[i]:SetText(i)
					node[i].text.MouseClick=function() SetCharacter(i) end
					subNodes[i] = node[i]:GetChildNodes()
					altNode[i]={}
					if Len(List[i].Alt)>0 then
						for j in orderedPairs(List[i].Alt) do
							altNode[i][j] = MyTreeNode()
							
							if List[j].Main then
								altNode[i][j].text:SetOutlineColor( highlight );
								altNode[i][j].text:SetFontStyle( Turbine.UI.FontStyle.Outline );
							else
								altNode[i][j].text:SetFontStyle( Turbine.UI.FontStyle.None );
							end
							
							
							subNodes[i]:Add( altNode[i][j] )
								altNode[i][j]:SetText(j)
								altNode[i][j].text.MouseClick=function() SetCharacter(j) end
						end
					end
					node[i].HIDER = MyTreeNode()
					subNodes[i]:Add( node[i].HIDER )
					node[i].HIDER:SetText("Add New Alt",Turbine.UI.Color(0,1,0))
					node[i].HIDER.text.MouseClick=function() AddAlt(i) end
			end			
		end
			addcharnode = MyTreeNode()
			rootNodes:Add( addcharnode )
			addcharnode:SetText("Add New Character",Turbine.UI.Color(0,1,0))
			addcharnode.text.MouseClick=function() AddCharacter() end
end

function Search()
	local txt1
	local txt2
	local vis
	if SearchString==nil then SearchString="" end
	txt1=string.lower(string.gsub(SearchString,"[^%a]",""))
	for i in pairs(List) do
		txt2=string.lower(string.gsub(i,"[^%a]",""))
		if string.find(txt2,txt1) then 
			vis=true
		else
			vis=false
		end
		
		--If only mains are shown, then on a search the trees for alts that fit the pattern too.
		if ShowOnlyMains then
			for j in pairs(List[i].Alt) do
				txt2=string.lower(string.gsub(j,"[^%a]",""))
				if string.find(txt2,txt1) then 
					vis=true
					altNode[i][j].vis=true
					else
					altNode[i][j].vis=false
				end
			end
		end
		
		--Now to show or hide.

		if not ShowOnlyMains then
			--If showing all characters then, show or hide the character and collapse all trees.
			node[i]:SetVisible(vis)  										--Show or hide the character		
			node[i]:SetExpanded(false)								--Collapse the trees
		else
			--If showing just mains, then expand all trees where a character fits the search pattern and then show or hide alts as appropriate.
			node[i]:SetVisible(vis)
			node[i]:SetExpanded(vis)
			for j in pairs(List[i].Alt) do
				altNode[i][j]:SetVisible(altNode[i][j].vis)					
			end
		end	

		--Hide the "add new alt" link. This is not appropriate to be visible whilst searching.
		node[i].HIDER:SetVisible(false)
		addcharnode:SetVisible(false)
			
	end
end

function RightFrame()

	Display.RightFrame=Frame()
		Display.RightFrame:SetParent(Display)
		
		Display.NameLabel=Turbine.UI.Label()
		Display.NameLabel:SetParent(Display.RightFrame)
		Display.NameLabel:SetPosition(2,2)
		
		Display.Name=Turbine.UI.TextBox()
		Display.Name:SetParent(Display.RightFrame)
		Display.Name:SetPosition(52,2)
		
		Display.NoteLabel=Turbine.UI.Label()
		Display.NoteLabel:SetParent(Display.RightFrame)
		Display.NoteLabel:SetPosition(2,22)
		
		Display.NoteScrollBar = Turbine.UI.Lotro.ScrollBar()
		Display.NoteScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
		Display.NoteScrollBar:SetParent( Display.RightFrame )
		Display.NoteScrollBar:SetPosition( 2,42 )
		
		Display.Note=Turbine.UI.TextBox()
		Display.Note:SetParent(Display.RightFrame)	
		Display.Note:SetPosition(12,42)
		
		Display.Note:SetVerticalScrollBar( Display.NoteScrollBar )
		
		Display.Apply=Turbine.UI.Lotro.Button()
		Display.Apply:SetParent(Display.RightFrame)
		Display.Apply:SetText("Apply")
		
		Display.Delete=Turbine.UI.Lotro.Button()
		Display.Delete:SetParent(Display.RightFrame)
		Display.Delete:SetText("Delete")
		
		Display.Split=Turbine.UI.Lotro.Button()
		Display.Split:SetParent(Display.RightFrame)
		Display.Split:SetText("Split from Alts")
		
		Display.Main=Turbine.UI.Lotro.Button()
		Display.Main:SetParent(Display.RightFrame)
		Display.Main:SetText("Set as Main")
		
	Display.RightFrame2=Frame()
		Display.RightFrame2:SetParent(Display.RightFrame)
	
	Display.altListBox=Turbine.UI.ListBox()
		Display.altListBox:SetParent(Display.RightFrame2)
		Display.altListBox:SetPosition(10,2)
		
		-- Give the alt view a scroll bar.
	Display.alt = Turbine.UI.Lotro.ScrollBar()
		Display.alt:SetOrientation( Turbine.UI.Orientation.Vertical )
		Display.alt:SetParent( Display.RightFrame2 )
		Display.alt:SetPosition( 0, 2 )
		
		Display.altListBox:SetVerticalScrollBar( Display.alt )
			
		table.insert(Display.RightFrame.SizeChange,function()
		
			Display.RightFrame:SetPosition(20+size.w,40)
			
			Display.Note:SetSize(size.w-4-10-10,3*size.h/4-18*2-2-25)
			Display.NoteScrollBar:SetSize(10,3*size.h/4-18*2-2-25)
			
			ButtonW=size.w/4
			Display.Apply:SetWidth(ButtonW)
			Display.Apply:SetPosition(2,size.h-25+2)
			Display.Delete:SetWidth(ButtonW)
			Display.Delete:SetPosition(2+ButtonW,size.h-25+2)
			Display.Split:SetWidth(ButtonW)
			Display.Split:SetPosition(2+2*ButtonW,size.h-25+2)
			Display.Main:SetWidth(ButtonW)
			Display.Main:SetPosition (2+3*ButtonW,size.h-25+2)
			Display.Name:SetSize(size.w-4-50,18)
			Display.NoteLabel:SetSize(size.w-4,18)
			
			Display.RightFrame2:SetSize(size.w,size.h/4-5)
			Display.RightFrame2:SetPosition(0,3*size.h/4-20)
			Display.alt:SetSize( 10,size.h/4-9 )
			Display.altListBox:SetSize(size.w-12,size.h/4-9)
		end)
		
		Display.RightFrame:SetSize(size.w,size.h)
end

function SetCharacter(char)
	Char=char	--Global version of the variable, used in the showwindow function
	
	Display.NameLabel:SetSize(50,18)
	Display.Name:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
	Display.NameLabel:SetText("Name: ")
	
	Display.Name:SetText(char)

	Display.NoteLabel:SetText("Character Notes:")

	Display.Note:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1))
	Display.Note:SetText(List[char].Note)

		Display.altListBox:ClearItems()
		if Len(List[char].Alt)>0 then
		local txtbx={}
		for j in orderedPairs(List[char].Alt) do
			txtbx.j=Turbine.UI.Label()
			txtbx.j:SetSize(2000,12)--(size.w-12,14)
			local txt=j..":"
			if List[j].Note~=nil then txt=txt..List[j].Note end
			txtbx.j:SetText(txt)
			txtbx.j.MouseClick=function() SetCharacter(j) end
			Display.altListBox:AddItem(txtbx.j)
		end
	end
	
	Display.Apply.Click=function()
		--Note Changed
		List[char].Note=Display.Note:GetText()
		
		--Rename
		local newchar=fixtext(Display.Name:GetText())
		if newchar~=char then
			List[newchar]=List[char]
			for i in pairs(List) do
				List[i].Alt[newchar],List[i].Alt[char]=List[i].Alt[char],nil
			end
			
			List[char]=nil
			ParseList()
			ShowWindow()
		end
	end
	
	Display.Delete.Click=function()
		--Delete character
		for i in pairs(List) do
			List[i].Alt[char]=nil
		end
		
		Char=nil
		
		List[char]=nil
		ParseList()
		ShowWindow()
	end
	
	Display.Split.Click=function()
		--Split this character from the alt lists of everyone.
		for i in pairs(List) do
			List[i].Alt[char]=nil
		end
		
		List[char].Alt=nil
		List[char].Alt={}

		ParseList()
		ShowWindow()
	end
	
	Display.Main.Click=function()
		for i in pairs(List[char].Alt) do
			List[i].Main=nil
		end
		List[char].Main=true
		
		ParseList()
		ShowWindow()
	end
	
end

ShowCommand = Turbine.ShellCommand()
function ShowCommand:Execute(command, i)
	Display=nil
	ShowWindow()
end
Turbine.Shell.AddCommand('at', ShowCommand)

Plugins["AltTracker"].Unload = function( sender, args )
	if fold then width=width/2 end
	Turbine.PluginData.Save( Turbine.DataScope.Server, "AltTracker", {List,x,y,width,height} )
end
local i=Turbine.PluginData.Load( Turbine.DataScope.Server, "AltTracker" )
if i==nil then 

	List={}	width=700 height=300 x=100 y=100
	
	size={}
	size.w=335
	size.h=250
	
	ShowWindow()
else 
	List,x,y,width,height=i[1],i[2],i[3],i[4],i[5]

end

	if x<0 then x=0 end
	if y<0 then y=0 end
	if x==nil then x=100 end
	if y==nil then y=100 end
	if List==nil then List={} end
	
	
	size={}
	size.w=(width-30)/2
	size.h=height-50
	
--[[List={}
	List.Geoff={Note="Has bad breath.", Alt={Mary=true,Mungo=true}}
	List.Mary={Note="Nowt",	Alt={Geoff=true,Mungo=true}}
	List.Mungo={Note="Nuffink",	Alt={Geoff=true}}
	List.Dvarlin={Note="Me",	Alt={}}]]
ParseList()
Turbine.Shell.WriteLine("Welcome to Alt Tracker. Please enter /at to show the window.")