Frame=class(Turbine.UI.Control)

function Frame:Constructor()
Turbine.UI.Control.Constructor( self );
	self.base=Turbine.UI.Control()
	self.base:SetBackColor(Turbine.UI.Color(1,1,1,1))
	self.base:SetParent(self)
	self.high=Turbine.UI.Control()
	self.high:SetBackColor(Turbine.UI.Color(1,0,0,0))
	self.high:SetPosition(1,1)
	self.high:SetParent(self.base)
	self:SetVisible(true)

	self.SizeChanged=function()
		for i=1,#self.SizeChange do
			self.SizeChange[i]()
		end
	end
	self.SizeChange={}
	table.insert(self.SizeChange,function()
		local x,y=self:GetSize()
		self.base:SetSize(x,y)
		self.high:SetSize(x-2,y-2)
	end)
end
	
-- Define a tree node class to put into the tree.
MyTreeNode = class( Turbine.UI.TreeNode );
		
function MyTreeNode:Constructor()
	Turbine.UI.TreeNode.Constructor( self );
	self.text=Turbine.UI.Label()
	self.text:SetParent(self)
	self:SetSize( 500, 18 );
	self.SizeChanged=function()
		self.text:SetSize(self:GetSize())
	end
end

function MyTreeNode:SetText(s,t)
	self.text:SetText(s)
	if t~=nil then
		self.text:SetForeColor(t)
	end
end

function fixtext(txt)
--Removes odd characters and makes the first letter only upper case
	txt=string.gsub(txt,"[^%a]","")
	txt=string.upper(string.sub(txt,1,1))..string.lower(string.sub(txt,2))
	return txt
end


--Ordered pair functions from http://lua-users.org/wiki/SortedIteration
function __genOrderedIndex( t )
    local orderedIndex = {}
    for key in pairs(t) do
        table.insert( orderedIndex, key )
    end
    table.sort( orderedIndex )
    return orderedIndex
end

function orderedNext(t, state)
    -- Equivalent of the next function, but returns the keys in the alphabetic
    -- order. We use a temporary ordered key table that is stored in the
    -- table being iterated.

    --print("orderedNext: state = "..tostring(state) )
    if state == nil then
        -- the first time, generate the index
        t.__orderedIndex = __genOrderedIndex( t )
        key = t.__orderedIndex[1]
        return key, t[key]
    end
    -- fetch the next value
    key = nil
    for i = 1,table.getn(t.__orderedIndex) do
        if t.__orderedIndex[i] == state then
            key = t.__orderedIndex[i+1]
        end
    end

    if key then
        return key, t[key]
    end

    -- no more value to return, cleanup
    t.__orderedIndex = nil
    return
end

function orderedPairs(t)
    -- Equivalent of the pairs() function on tables. Allows to iterate
    -- in order
    return orderedNext, t, nil
end

--Return the length of a table that uses dictionary keys
function Len(t)
	local count=0
	for i in pairs(t) do
		count=count+1
	end
	return count
end

--Return the size of the parent
function GetParentSize(frame)
	return frame:GetParent():GetSize()
end

function ParseList()
	for z in pairs(List) do
		--Check integrity of list
		for i in pairs(List) do
			if List[i].Alt~=nil then
				for j in pairs(List[i].Alt) do
					if List[j]==nil then Turbine.Shell.WriteLine(i.." knows "..j..". That is a new character!") List[j]={Notes="",Alt={}} ParseList() end
					if List[j].Alt==nil then List[j].Alt={} end
					List[j].Alt[i]=true
					for k in pairs(List[j].Alt) do
						List[i].Alt[k]=true
					end
				end
			end
		end
	end
	
	for z in pairs(List) do
		if List[z].Alt==nil then List[z].Alt={} end
		List[z].Alt[z]=nil
	end
	
	--Check that each character has a Main
	
	for z in pairs(List) do
		local m=false
		for i in pairs(List[z].Alt) do
			if List[i].Main then m=true end
		end
		if not m then List[z].Main=true end
	end
	
end


TextEntry=Turbine.UI.Lotro.Window()

	TextEntry:SetPosition(100,100)
	TextEntry:SetSize(300,10)
	TextEntry:SetVisible(false)
	TextEntry.Textbox=Turbine.UI.TextBox()
	TextEntry.Textbox:SetParent(TextEntry)
	TextEntry.Textbox:SetPosition(10,40)
	TextEntry.Textbox:SetSize(180,20)
	
	
function AddCharacter()
	TextEntry:SetVisible(true)
	TextEntry:SetPosition(x+50,y+50)
	TextEntry:SetText("Add Character")
	TextEntry.Textbox:SetText("ENTER HERE")
	TextEntry.Textbox.FocusGained=function() local txt=TextEntry.Textbox:GetText() if txt=="ENTER HERE" then TextEntry.Textbox:SetText("") end end
	
	TextEntry.Closed=function()
		local txt=fixtext(TextEntry.Textbox:GetText())
		if txt==nil then return end
		if txt=="" then return end
		if txt=="ENTER HERE" then return end

		--Check character does not already exist
			if List[txt]~=nil then return end
		
		List[txt]={Note="",	Alt={}}
		ParseList()
		ShowWindow()
	end
	TextEntry:SetZOrder(999)
end

function AddAlt(i)
	TextEntry:SetVisible(true)
	TextEntry:SetPosition(x+50,y+50)
	TextEntry.Textbox:SetText("ENTER HERE")
	TextEntry:SetText("Add alt")
	TextEntry.Textbox.FocusGained=function() local txt=TextEntry.Textbox:GetText() if txt=="ENTER HERE" then TextEntry.Textbox:SetText("") end end
	
	TextEntry.Closed=function()
		local txt=fixtext(TextEntry.Textbox:GetText())
		if txt==i then return end
		if txt==nil then return end
		if txt=="" then return end
		if txt=="ENTER HERE" then return end
		
		List[i].Alt[txt]=true

		ParseList()
		ShowWindow()
	end
	TextEntry:SetZOrder(999)
end